Package org.eclipse.jdt.core.dom

## Class SuperMethodInvocation

- java.lang.Object
- - org.eclipse.jdt.core.dom.ASTNode
  - - org.eclipse.jdt.core.dom.Expression
    - - org.eclipse.jdt.core.dom.SuperMethodInvocation

    public class SuperMethodInvocation
    extends Expression

Simple or qualified "super" method invocation expression AST node type.

     SuperMethodInvocation:
         [ ClassName . ] super .
             [ < Type { , Type } > ]
             Identifier ( [ Expression { , Expression } ] )

Since:
  2.0
Restriction:
  This class is not intended to be instantiated by clients.

### Field Summary

Fields
`static ChildListPropertyDescriptor` `ARGUMENTS_PROPERTY` The "arguments" structural property of this node type (element type: `Expression`).
`static ChildPropertyDescriptor` `NAME_PROPERTY` The "name" structural property of this node type (child type: `SimpleName`).
`static ChildPropertyDescriptor` `QUALIFIER_PROPERTY` The "qualifier" structural property of this node type (child type: `Name`).
`static ChildListPropertyDescriptor` `TYPE_ARGUMENTS_PROPERTY` The "typeArguments" structural property of this node type (element type: `Type`) (added in JLS3 API).

### Fields inherited from class org.eclipse.jdt.core.dom.ASTNode

`ANNOTATION_TYPE_DECLARATION, ANNOTATION_TYPE_MEMBER_DECLARATION, ANONYMOUS_CLASS_DECLARATION, ARRAY_ACCESS, ARRAY_CREATION, ARRAY_INITIALIZER, ARRAY_TYPE, ASSERT_STATEMENT, ASSIGNMENT, BLOCK, BLOCK_COMMENT, BOOLEAN_LITERAL, BREAK_STATEMENT, CAST_EXPRESSION, CATCH_CLAUSE, CHARACTER_LITERAL, CLASS_INSTANCE_CREATION, COMPILATION_UNIT, CONDITIONAL_EXPRESSION, CONSTRUCTOR_INVOCATION, CONTINUE_STATEMENT, CREATION_REFERENCE, DIMENSION, DO_STATEMENT, EMPTY_STATEMENT, ENHANCED_FOR_STATEMENT, ENUM_CONSTANT_DECLARATION, ENUM_DECLARATION, EXPORTS_DIRECTIVE, EXPRESSION_METHOD_REFERENCE, EXPRESSION_STATEMENT, FIELD_ACCESS, FIELD_DECLARATION, FOR_STATEMENT, IF_STATEMENT, IMPORT_DECLARATION, INFIX_EXPRESSION, INITIALIZER, INSTANCEOF_EXPRESSION, INTERSECTION_TYPE, JAVADOC, LABELED_STATEMENT, LAMBDA_EXPRESSION, LINE_COMMENT, MALFORMED, MARKER_ANNOTATION, MEMBER_REF, MEMBER_VALUE_PAIR, METHOD_DECLARATION, METHOD_INVOCATION, METHOD_REF, METHOD_REF_PARAMETER, MODIFIER, MODULE_DECLARATION, MODULE_MODIFIER, NAME_QUALIFIED_TYPE, NORMAL_ANNOTATION, NULL_LITERAL, NUMBER_LITERAL, OPENS_DIRECTIVE, ORIGINAL, PACKAGE_DECLARATION, PARAMETERIZED_TYPE, PARENTHESIZED_EXPRESSION, POSTFIX_EXPRESSION, PREFIX_EXPRESSION, PRIMITIVE_TYPE, PROTECT, PROVIDES_DIRECTIVE, QUALIFIED_NAME, QUALIFIED_TYPE, RECOVERED, REQUIRES_DIRECTIVE, RETURN_STATEMENT, SIMPLE_NAME, SIMPLE_TYPE, SINGLE_MEMBER_ANNOTATION, SINGLE_VARIABLE_DECLARATION, STRING_LITERAL, SUPER_CONSTRUCTOR_INVOCATION, SUPER_FIELD_ACCESS, SUPER_METHOD_INVOCATION, SUPER_METHOD_REFERENCE, SWITCH_CASE, SWITCH_EXPRESSION, SWITCH_STATEMENT, SYNCHRONIZED_STATEMENT, TAG_ELEMENT, TEXT_BLOCK, TEXT_ELEMENT, THIS_EXPRESSION, THROW_STATEMENT, TRY_STATEMENT, TYPE_DECLARATION, TYPE_DECLARATION_STATEMENT, TYPE_LITERAL, TYPE_METHOD_REFERENCE, TYPE_PARAMETER, UNION_TYPE, USES_DIRECTIVE, VARIABLE_DECLARATION_EXPRESSION, VARIABLE_DECLARATION_FRAGMENT, VARIABLE_DECLARATION_STATEMENT, WHILE_STATEMENT, WILDCARD_TYPE, YIELD_STATEMENT`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`List` `arguments()` Returns the live ordered list of argument expressions in this "super" method invocation expression.
`SimpleName` `getName()` Returns the name of the method invoked in this expression.
`Name` `getQualifier()` Returns the qualifier of this "super" method invocation expression, or `null` if there is none.
`boolean` `isResolvedTypeInferredFromExpectedType()` Returns true if the resolved return type has been inferred from the assignment context (JLS3 15.12.2.8), false otherwise.
`static List` `propertyDescriptors​(int apiLevel)` Returns a list of structural property descriptors for this node type.
`IMethodBinding` `resolveMethodBinding()` Resolves and returns the binding for the method invoked by this expression.
`void` `setName​(SimpleName name)` Sets the name of the method invoked in this expression to the given name.
`void` `setQualifier​(Name name)` Sets or clears the qualifier of this "super" method invocation expression.
`List` `typeArguments()` Returns the live ordered list of type arguments of this method invocation (added in JLS3 API).

### Methods inherited from class org.eclipse.jdt.core.dom.Expression

`resolveBoxing, resolveConstantExpressionValue, resolveTypeBinding, resolveUnboxing`

### Methods inherited from class org.eclipse.jdt.core.dom.ASTNode

`accept, copySubtree, copySubtrees, delete, equals, getAST, getFlags, getLength, getLocationInParent, getNodeType, getParent, getProperty, getRoot, getStartPosition, getStructuralProperty, hashCode, nodeClassForType, properties, setFlags, setProperty, setSourceRange, setStructuralProperty, structuralPropertiesForType, subtreeBytes, subtreeMatch, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### QUALIFIER_PROPERTY

    public static final ChildPropertyDescriptor QUALIFIER_PROPERTY

The "qualifier" structural property of this node type (child type: `Name`).

Since:
  3.0

#### TYPE_ARGUMENTS_PROPERTY

    public static final ChildListPropertyDescriptor TYPE_ARGUMENTS_PROPERTY

The "typeArguments" structural property of this node type (element type: `Type`) (added in JLS3 API).

Since:
  3.1

#### NAME_PROPERTY

    public static final ChildPropertyDescriptor NAME_PROPERTY

The "name" structural property of this node type (child type: `SimpleName`).

Since:
  3.0

#### ARGUMENTS_PROPERTY

    public static final ChildListPropertyDescriptor ARGUMENTS_PROPERTY

The "arguments" structural property of this node type (element type: `Expression`).

Since:
  3.0

### Method Detail

#### propertyDescriptors

    public static List propertyDescriptors​(int apiLevel)

Returns a list of structural property descriptors for this node type. Clients must not modify the result.

Parameters:
  `apiLevel` - the API level; one of the `AST.JLS*` constants
Returns:
  a list of property descriptors (element type: `StructuralPropertyDescriptor`)
Since:
  3.0

#### getQualifier

    public Name getQualifier()

Returns the qualifier of this "super" method invocation expression, or `null` if there is none.

Returns:
  the qualifier name node, or `null` if there is none

#### isResolvedTypeInferredFromExpectedType

    public boolean isResolvedTypeInferredFromExpectedType()

Returns true if the resolved return type has been inferred from the assignment context (JLS3 15.12.2.8), false otherwise.

This information is available only when bindings are requested when the AST is being built

.

Returns:
  true if the resolved return type has been inferred from the assignment context (JLS3 15.12.2.8), false otherwise
Since:
  3.3

#### setQualifier

    public void setQualifier​(Name name)

Sets or clears the qualifier of this "super" method invocation expression.

Parameters:
  `name` - the qualifier name node, or `null` if there is none
Throws:
  `IllegalArgumentException` - if:
  - the node belongs to a different AST
  - the node already has a parent

#### typeArguments

    public List typeArguments()

Returns the live ordered list of type arguments of this method invocation (added in JLS3 API).

Returns:
  the live list of type arguments (element type: `Type`)
Throws:
  `UnsupportedOperationException` - if this operation is used in a JLS2 AST
Since:
  3.1

#### getName

    public SimpleName getName()

Returns the name of the method invoked in this expression.

Returns:
  the method name node

#### setName

    public void setName​(SimpleName name)

Sets the name of the method invoked in this expression to the given name.

Parameters:
  `name` - the new method name
Throws:
  `IllegalArgumentException` - if:
  - the node belongs to a different AST
  - the node already has a parent

#### arguments

    public List arguments()

Returns the live ordered list of argument expressions in this "super" method invocation expression.

Returns:
  the live list of argument expressions (element type: `Expression`)

#### resolveMethodBinding

    public IMethodBinding resolveMethodBinding()

Resolves and returns the binding for the method invoked by this expression.

Note that bindings are generally unavailable unless requested when the AST is being built.

Returns:
  the method binding, or `null` if the binding cannot be resolved
Since:
  2.1